import { DataFilterState, DataFilterOptions, DataSpecs, DataFilterAction } from "./models";
import { Loop } from "redux-loop";
declare const createApiCaller: <TFilterMap, TDomain, TK extends keyof TFilterMap = keyof TFilterMap>(filterName: TK) => (state: DataFilterState<TFilterMap[TK]>, request: DataSpecs<TFilterMap[TK]>, options: DataFilterOptions<TFilterMap[TK], TDomain>) => DataFilterState<TFilterMap[keyof TFilterMap]> | Loop<DataFilterState<TFilterMap[keyof TFilterMap]>, DataFilterAction<TFilterMap, TDomain>>;
export default createApiCaller;
