"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_loop_1 = require("redux-loop");
var createApiCaller = function (filterName) {
    return function (state, request, options) {
        return redux_loop_1.loop(__assign(__assign({}, state), { error: null, isLoading: true, lastRequest: request }), redux_loop_1.Cmd.run(options.searchApi, {
            args: [request],
            successActionCreator: function (rs) { return ({
                type: "FILTER/REQUEST_SUCCESS",
                filterName: filterName,
                request: request,
                payload: rs
            }); },
            failActionCreator: function (err) { return ({
                type: "FILTER/REQUEST_ERROR",
                filterName: filterName,
                request: request,
                payload: err
            }); }
        }));
    };
};
exports.default = createApiCaller;
