import { DataStateSelector } from "./models";
declare type Denormalizer<TEntity> = (key: string) => Partial<TEntity>;
declare const _default: <TState, TFilterMap extends object, TDomain extends object>(stateSelector: DataStateSelector<TState, TFilterMap, TDomain>) => <TK extends keyof TDomain>(entityName: TK) => Denormalizer<TDomain[TK]>;
export default _default;
