import { DataSpecs } from "../index";
import { Contact } from "../storeSample/domainModels";
import { ContactsAutoComplete } from "../storeSample/queryModels";
export declare type ContactAutoCompleteApi = (q: DataSpecs<ContactsAutoComplete>) => Promise<{
    total: number;
    matches: Contact[];
}>;
export declare type GetContact = () => Promise<{
    total: number;
    matches: Contact[];
}>;
declare type FindContactByKeyApi = (id: string) => Promise<Contact>;
declare type UpdateContactApi = (updates: Partial<Contact>) => Promise<{}>;
declare type DeleteContactApi = (id: string) => Promise<{}>;
export declare type ApiCatalog = {
    contacts: ContactsApi;
};
export interface ContactsApi {
    findByKey: FindContactByKeyApi;
    update: UpdateContactApi;
    delete: DeleteContactApi;
}
export {};
